Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90	(revision 3938)
@@ -5,4 +5,5 @@
    !!======================================================================
    !! History :  3.3  ! 2010-09  (M. Leclair)  Original code 
+   !!                 ! 2012-10  (C. Rousset)  add iom_put
    !!----------------------------------------------------------------------
 
@@ -21,4 +22,8 @@
    USE bdy_par         ! (for lk_bdy)
    USE timing          ! preformance summary
+   USE iom             ! I/O manager
+   USE lib_fortran     ! glob_sum
+   USE restart         ! ocean restart
+   USE wrk_nemo         ! work arrays
 
    IMPLICIT NONE
@@ -26,16 +31,13 @@
 
    PUBLIC   dia_hsb        ! routine called by step.F90
-   PUBLIC   dia_hsb_init   ! routine called by opa.F90
+   PUBLIC   dia_hsb_init   ! routine called by nemogcm.F90
+   PUBLIC   dia_hsb_rst    ! routine called by step.F90
 
    LOGICAL, PUBLIC ::   ln_diahsb  = .FALSE.   !: check the heat and salt budgets
 
-   INTEGER                                 ::   numhsb                           !
-   REAL(dp)                                ::   surf_tot   , vol_tot             !
-   REAL(dp)                                ::   frc_t      , frc_s     , frc_v   ! global forcing trends
-   REAL(dp)                                ::   fact1                            ! conversion factors
-   REAL(dp)                                ::   fact21    , fact22               !     -         -
-   REAL(dp)                                ::   fact31    , fact32               !     -         -
-   REAL(dp), DIMENSION(:,:)  , ALLOCATABLE ::   surf      , ssh_ini              !
-   REAL(dp), DIMENSION(:,:,:), ALLOCATABLE ::   hc_loc_ini, sc_loc_ini, e3t_ini  !
+   REAL(wp), SAVE                                ::   frc_t      , frc_s     , frc_v   ! global forcing trends
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   ssh_ini              !
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   hc_loc_ini, sc_loc_ini, e3t_ini  !
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   hcssh_loc_ini, scssh_loc_ini     !
 
    !! * Substitutions
@@ -61,88 +63,118 @@
       !!	            - Compute the contribution of forcing and remove it from these deviations
       !!
-      !! ** Action : Write the results in the 'heat_salt_volume_budgets.txt' ASCII file
       !!---------------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       !!
       INTEGER    ::   jk                          ! dummy loop indice
-      REAL(dp)   ::   zdiff_hc    , zdiff_sc      ! heat and salt content variations
-      REAL(dp)   ::   zdiff_v1    , zdiff_v2      ! volume variation
-      REAL(dp)   ::   z1_rau0                     ! local scalars
-      REAL(dp)   ::   zdeltat                     !    -     -
-      REAL(dp)   ::   z_frc_trd_t , z_frc_trd_s   !    -     -
-      REAL(dp)   ::   z_frc_trd_v                 !    -     -
-      !!---------------------------------------------------------------------------
-      IF( nn_timing == 1 )   CALL timing_start('dia_hsb')
-
+      REAL(wp)   ::   zdiff_hc    , zdiff_sc      ! heat and salt content variations
+      REAL(wp)   ::   zdiff_v1    , zdiff_v2      ! volume variation
+      REAL(wp)   ::   z_hc        , z_sc          ! heat and salt content
+      REAL(wp)   ::   z_v1        , z_v2          ! volume
+      REAL(wp)   ::   z1_rau0                     ! local scalars
+      REAL(wp)   ::   zdeltat                     !    -     -
+      REAL(wp)   ::   z_frc_trd_t , z_frc_trd_s   !    -     -
+      REAL(wp)   ::   z_frc_trd_v                 !    -     -
+      REAL(wp), POINTER, DIMENSION(:,:)   ::   zsurf              !
+      !!---------------------------------------------------------------------------
+      IF( nn_timing == 1 )   CALL timing_start('dia_hsb')      
+
+      CALL wrk_alloc( jpi, jpj, zsurf )
+  
+      zsurf(:,:) = e1t(:,:) * e2t(:,:) * tmask(:,:,1) * tmask_i(:,:)      ! masked surface grid cell area
+      
       ! ------------------------- !
       ! 1 - Trends due to forcing !
       ! ------------------------- !
       z1_rau0 = 1.e0 / rau0
-      z_frc_trd_v = z1_rau0 * SUM( - ( emp(:,:) - rnf(:,:) ) * surf(:,:) )     ! volume fluxes
-      z_frc_trd_t =           SUM( sbc_tsc(:,:,jp_tem) * surf(:,:) )     ! heat fluxes
-      z_frc_trd_s =           SUM( sbc_tsc(:,:,jp_sal) * surf(:,:) )     ! salt fluxes
+      z_frc_trd_v = z1_rau0 * glob_sum( - ( emp(:,:) - rnf(:,:) ) * zsurf(:,:) ) ! volume fluxes
+      z_frc_trd_t =           glob_sum( sbc_tsc(:,:,jp_tem) * zsurf(:,:) )       ! heat fluxes
+      z_frc_trd_s =           glob_sum( sbc_tsc(:,:,jp_sal) * zsurf(:,:) )       ! salt fluxes
       ! Add penetrative solar radiation
-      IF( ln_traqsr )   z_frc_trd_t = z_frc_trd_t + ro0cpr * SUM( qsr     (:,:) * surf(:,:) )
+      IF( ln_traqsr )   z_frc_trd_t = z_frc_trd_t + ro0cpr * glob_sum( qsr     (:,:) * zsurf(:,:) )
       ! Add geothermal heat flux
-      IF( ln_trabbc )   z_frc_trd_t = z_frc_trd_t + ro0cpr * SUM( qgh_trd0(:,:) * surf(:,:) )
-      IF( lk_mpp ) THEN
-         CALL mpp_sum( z_frc_trd_v )
-         CALL mpp_sum( z_frc_trd_t )
-      ENDIF
+      IF( ln_trabbc )   z_frc_trd_t = z_frc_trd_t + ro0cpr * glob_sum( qgh_trd0(:,:) * zsurf(:,:) )
+      !
       frc_v = frc_v + z_frc_trd_v * rdt
       frc_t = frc_t + z_frc_trd_t * rdt
       frc_s = frc_s + z_frc_trd_s * rdt
 
-      ! ----------------------- !
-      ! 2 -  Content variations !
-      ! ----------------------- !
-      zdiff_v2 = 0.d0
-      zdiff_hc = 0.d0
-      zdiff_sc = 0.d0
+      ! ------------------------ !
+      ! 2a -  Content variations !
+      ! ------------------------ !
+      zdiff_v2 = 0._wp
+      zdiff_hc = 0._wp
+      zdiff_sc = 0._wp
       ! volume variation (calculated with ssh)
-      zdiff_v1 = SUM( surf(:,:) * tmask(:,:,1) * ( sshn(:,:) - ssh_ini(:,:) ) )
+      zdiff_v1 = glob_sum( zsurf(:,:) * ( sshn(:,:) - ssh_ini(:,:) ) )
       DO jk = 1, jpkm1
          ! volume variation (calculated with scale factors)
-         zdiff_v2 = zdiff_v2 + SUM( surf(:,:) * tmask(:,:,jk)   &
-            &                       * ( fse3t_n(:,:,jk)         &
-            &                           - e3t_ini(:,:,jk) ) )
+         zdiff_v2 = zdiff_v2 + glob_sum( zsurf(:,:) * tmask(:,:,jk) * ( fse3t_n(:,:,jk) - e3t_ini(:,:,jk) ) )
          ! heat content variation
-         zdiff_hc = zdiff_hc + SUM( surf(:,:) * tmask(:,:,jk)          &
-            &                       * ( fse3t_n(:,:,jk) * tsn(:,:,jk,jp_tem)   &
+         zdiff_hc = zdiff_hc + glob_sum( zsurf(:,:) * tmask(:,:,jk) * ( fse3t_n(:,:,jk) * tsn(:,:,jk,jp_tem)   &
             &                           - hc_loc_ini(:,:,jk) ) )
          ! salt content variation
-         zdiff_sc = zdiff_sc + SUM( surf(:,:) * tmask(:,:,jk)          &
-            &                       * ( fse3t_n(:,:,jk) * tsn(:,:,jk,jp_sal)   &
+         zdiff_sc = zdiff_sc + glob_sum( zsurf(:,:) * tmask(:,:,jk) * ( fse3t_n(:,:,jk) * tsn(:,:,jk,jp_sal)   &
             &                           - sc_loc_ini(:,:,jk) ) )
       ENDDO
 
-      IF( lk_mpp ) THEN
-         CALL mpp_sum( zdiff_hc )
-         CALL mpp_sum( zdiff_sc )
-         CALL mpp_sum( zdiff_v1 )
-         CALL mpp_sum( zdiff_v2 )
-      ENDIF
-
       ! Substract forcing from heat content, salt content and volume variations
-      zdiff_v1 = zdiff_v1 - frc_v
-      zdiff_v2 = zdiff_v2 - frc_v
-      zdiff_hc = zdiff_hc - frc_t
-      zdiff_sc = zdiff_sc - frc_s
+      !frc_v = zdiff_v2 - frc_v
+      !frc_t = zdiff_hc - frc_t
+      !frc_s = zdiff_sc - frc_s
       
+      ! add ssh if not vvl
+#ifndef key_vvl
+     zdiff_v2 = zdiff_v2 + zdiff_v1
+     zdiff_hc = zdiff_hc + glob_sum( zsurf(:,:) * ( sshn(:,:) * tsn(:,:,1,jp_tem)   &
+            &                           - hcssh_loc_ini(:,:) ) )
+     zdiff_sc = zdiff_sc + glob_sum( zsurf(:,:) * ( sshn(:,:) * tsn(:,:,1,jp_sal)   &
+            &                           - scssh_loc_ini(:,:) ) )
+#endif 
+      !
+      ! ----------------------- !
+      ! 2b -  Content           !
+      ! ----------------------- !
+      z_v2 = 0._wp
+      z_hc = 0._wp
+      z_sc = 0._wp
+      ! volume (calculated with ssh)
+      z_v1 = glob_sum( zsurf(:,:) * sshn(:,:) )
+      DO jk = 1, jpkm1
+         ! volume (calculated with scale factors)
+         z_v2 = z_v2 + glob_sum( zsurf(:,:) * tmask(:,:,jk) * fse3t_n(:,:,jk) )
+         ! heat content
+         z_hc = z_hc + glob_sum( zsurf(:,:) * tmask(:,:,jk) * fse3t_n(:,:,jk) * tsn(:,:,jk,jp_tem) )
+         ! salt content
+         z_sc = z_sc + glob_sum( zsurf(:,:) * tmask(:,:,jk) * fse3t_n(:,:,jk) * tsn(:,:,jk,jp_sal) )
+      ENDDO
+      ! add ssh if not vvl
+#ifndef key_vvl
+     z_v2 = z_v2 + z_v1
+     z_hc = z_hc + glob_sum( zsurf(:,:) * sshn(:,:) * tsn(:,:,1,jp_tem) )
+     z_sc = z_sc + glob_sum( zsurf(:,:) * sshn(:,:) * tsn(:,:,1,jp_sal) )
+#endif 
+
       ! ----------------------- !
       ! 3 - Diagnostics writing !
       ! ----------------------- !
       zdeltat  = 1.e0 / ( ( kt - nit000 + 1 ) * rdt )
-      WRITE(numhsb , 9020) kt , zdiff_hc / vol_tot , zdiff_hc * fact1  * zdeltat,                                &
-         &                      zdiff_sc / vol_tot , zdiff_sc * fact21 * zdeltat, zdiff_sc * fact22 * zdeltat,   &
-         &                      zdiff_v1           , zdiff_v1 * fact31 * zdeltat, zdiff_v1 * fact32 * zdeltat,   &
-         &                      zdiff_v2           , zdiff_v2 * fact31 * zdeltat, zdiff_v2 * fact32 * zdeltat
-
-      IF ( kt == nitend ) CLOSE( numhsb )
-
+!
+      CALL iom_put( 'bgtemper',z_hc / z_v2 )               ! Temperature (C) 
+      CALL iom_put( 'bgsaline',z_sc / z_v2 )               ! Salinity (psu)
+      !CALL iom_put( 'bgheatco',zdiff_hc*fact1*zdeltat )      ! Equivalent heat flux (W/m2)
+      !CALL iom_put( 'bgsaltco',zdiff_sc*fact21*zdeltat )     ! Equivalent water flux (mm/s)
+      CALL iom_put( 'bgheatco',zdiff_hc * rau0 * rcp * 1.e-9_wp ) ! Heat content variation (10^9 J)
+      CALL iom_put( 'bgsaltco',zdiff_sc * 1.e-9 )                        ! Salt content variation (psu*km3) 
+      CALL iom_put( 'bgvolssh',zdiff_v1 * 1.e-9 )                         ! volume ssh (km3)  
+      CALL iom_put( 'bgsshtot',zdiff_v1 / glob_sum(zsurf) )              ! ssh (m)  
+      CALL iom_put( 'bgvoltot',zdiff_v2 * 1.e-9 )                         ! volume total (km3) 
+      CALL iom_put( 'bgfrcvol',frc_v * 1.e-9 )                         ! vol - surface forcing (volume) 
+      CALL iom_put( 'bgfrctem',frc_t * rau0 * rcp * 1.e-9_wp ) ! hc  - surface forcing (heat content) 
+      CALL iom_put( 'bgfrcsal',frc_s * 1.e-9 )                         ! sc  - surface forcing (salt content) 
+      !
+      CALL wrk_dealloc( jpi, jpj, zsurf )
+      !
       IF( nn_timing == 1 )   CALL timing_stop('dia_hsb')
-
-9020  FORMAT(I5,11D15.7)
-      !
+!
    END SUBROUTINE dia_hsb
 
@@ -160,5 +192,4 @@
       !!             - Compute coefficients for conversion
       !!---------------------------------------------------------------------------
-      CHARACTER (len=32) ::   cl_name  ! output file name
       INTEGER            ::   jk       ! dummy loop indice
       INTEGER            ::   ierror   ! local integer
@@ -180,89 +211,119 @@
       IF( .NOT. ln_diahsb )   RETURN
 
-      ! ------------------- !
-      ! 1 - Allocate memory !
-      ! ------------------- !
-      ALLOCATE( hc_loc_ini(jpi,jpj,jpk), STAT=ierror )
-      IF( ierror > 0 ) THEN
-         CALL ctl_stop( 'dia_hsb: unable to allocate hc_loc_ini' )   ;   RETURN
-      ENDIF
-      ALLOCATE( sc_loc_ini(jpi,jpj,jpk), STAT=ierror )
-      IF( ierror > 0 ) THEN
-         CALL ctl_stop( 'dia_hsb: unable to allocate sc_loc_ini' )   ;   RETURN
-      ENDIF
-      ALLOCATE( e3t_ini(jpi,jpj,jpk)   , STAT=ierror )
-      IF( ierror > 0 ) THEN
-         CALL ctl_stop( 'dia_hsb: unable to allocate e3t_ini' )      ;   RETURN
-      ENDIF
-      ALLOCATE( surf(jpi,jpj)          , STAT=ierror )
-      IF( ierror > 0 ) THEN
-         CALL ctl_stop( 'dia_hsb: unable to allocate surf' )         ;   RETURN
-      ENDIF
-      ALLOCATE( ssh_ini(jpi,jpj)       , STAT=ierror )
-      IF( ierror > 0 ) THEN
-         CALL ctl_stop( 'dia_hsb: unable to allocate ssh_ini' )      ;   RETURN
-      ENDIF
-
-      ! ----------------------------------------------- !
-      ! 2 - Time independant variables and file opening !
-      ! ----------------------------------------------- !
-      WRITE(numout,*) "dia_hsb: heat salt volume budgets activated"
-      WRITE(numout,*) "~~~~~~~  output written in the 'heat_salt_volume_budgets.txt' ASCII file"
-      IF( lk_obc .or. lk_bdy ) THEN
-         CALL ctl_warn( 'dia_hsb does not take open boundary fluxes into account' )         
-      ENDIF
-      cl_name    = 'heat_salt_volume_budgets.txt'                         ! name of output file
-      surf(:,:) = e1t(:,:) * e2t(:,:) * tmask(:,:,1) * tmask_i(:,:)      ! masked surface grid cell area
-      surf_tot  = SUM( surf(:,:) )                                       ! total ocean surface area
-      vol_tot   = 0.d0                                                   ! total ocean volume
-      DO jk = 1, jpkm1
-         vol_tot  = vol_tot + SUM( surf(:,:) * tmask(:,:,jk)     &
-            &                      * fse3t_n(:,:,jk)         )
-      END DO
-      IF( lk_mpp ) THEN 
-         CALL mpp_sum( vol_tot )
-         CALL mpp_sum( surf_tot )
-      ENDIF
-
-      CALL ctl_opn( numhsb , cl_name , 'UNKNOWN' , 'FORMATTED' , 'SEQUENTIAL' , 1 , numout , lwp , 1 )
-      !                   12345678901234567890123456789012345678901234567890123456789012345678901234567890 -> 80
-      WRITE( numhsb, 9010 ) "kt   |     heat content budget     |            salt content budget             ",   &
-         !                                                   123456789012345678901234567890123456789012345 -> 45
-         &                                                  "|            volume budget (ssh)             ",   &
-         !                                                   678901234567890123456789012345678901234567890 -> 45
-         &                                                  "|            volume budget (e3t)             "
-      WRITE( numhsb, 9010 ) "     |      [C]         [W/m2]     |     [psu]        [mmm/s]          [SV]     ",   &
-         &                                                  "|     [m3]         [mmm/s]          [SV]     ",   &
-         &                                                  "|     [m3]         [mmm/s]          [SV]     "
-
-      ! --------------- !
-      ! 3 - Conversions ! (factors will be multiplied by duration afterwards)
-      ! --------------- !
-
-      ! heat content variation   =>   equivalent heat flux:
-      fact1  = rau0 * rcp / surf_tot                                         ! [C*m3]   ->  [W/m2]
-      ! salt content variation   =>   equivalent EMP and equivalent "flow": 
-      fact21 = 1.e3  / ( soce * surf_tot )                                   ! [psu*m3] ->  [mm/s]
-      fact22 = 1.e-6 / soce                                                  ! [psu*m3] ->  [Sv]
-      ! volume variation         =>   equivalent EMP and equivalent "flow":
-      fact31 = 1.e3  / surf_tot                                              ! [m3]     ->  [mm/s]
-      fact32 = 1.e-6                                                         ! [m3]     ->  [SV]
-
-      ! ---------------------------------- !
-      ! 4 - initial conservation variables !
-      ! ---------------------------------- !
-      ssh_ini(:,:) = sshn(:,:)                                       ! initial ssh
-      DO jk = 1, jpk
-         e3t_ini   (:,:,jk) = fse3t_n(:,:,jk)                        ! initial vertical scale factors
-         hc_loc_ini(:,:,jk) = tsn(:,:,jk,jp_tem) * fse3t_n(:,:,jk)   ! initial heat content
-         sc_loc_ini(:,:,jk) = tsn(:,:,jk,jp_sal) * fse3t_n(:,:,jk)   ! initial salt content
-      END DO
-      frc_v = 0.d0                                           ! volume       trend due to forcing
-      frc_t = 0.d0                                           ! heat content   -    -   -    -   
-      frc_s = 0.d0                                           ! salt content   -    -   -    -         
-      !
-9010  FORMAT(A80,A45,A45)
+         ! ------------------- !
+         ! 1 - Allocate memory !
+         ! ------------------- !
+         ALLOCATE( hc_loc_ini(jpi,jpj,jpk), STAT=ierror )
+         IF( ierror > 0 ) THEN
+            CALL ctl_stop( 'dia_hsb: unable to allocate hc_loc_ini' )   ;   RETURN
+         ENDIF
+         ALLOCATE( sc_loc_ini(jpi,jpj,jpk), STAT=ierror )
+         IF( ierror > 0 ) THEN
+            CALL ctl_stop( 'dia_hsb: unable to allocate sc_loc_ini' )   ;   RETURN
+         ENDIF
+         ALLOCATE( hcssh_loc_ini(jpi,jpj), STAT=ierror )
+         IF( ierror > 0 ) THEN
+            CALL ctl_stop( 'dia_hsb: unable to allocate hcssh_loc_ini' )   ;   RETURN
+         ENDIF
+         ALLOCATE( scssh_loc_ini(jpi,jpj), STAT=ierror )
+         IF( ierror > 0 ) THEN
+            CALL ctl_stop( 'dia_hsb: unable to allocate scssh_loc_ini' )   ;   RETURN
+         ENDIF
+         ALLOCATE( e3t_ini(jpi,jpj,jpk)   , STAT=ierror )
+         IF( ierror > 0 ) THEN
+            CALL ctl_stop( 'dia_hsb: unable to allocate e3t_ini' )      ;   RETURN
+         ENDIF
+         ALLOCATE( ssh_ini(jpi,jpj)       , STAT=ierror )
+         IF( ierror > 0 ) THEN
+            CALL ctl_stop( 'dia_hsb: unable to allocate ssh_ini' )      ;   RETURN
+         ENDIF
+         
+         ! ----------------------------------------------- !
+         ! 2 - Time independant variables and file opening !
+         ! ----------------------------------------------- !
+         WRITE(numout,*) "dia_hsb: heat salt volume budgets activated"
+         IF( lk_obc .or. lk_bdy ) THEN
+            CALL ctl_warn( 'dia_hsb does not take open boundary fluxes into account' )         
+         ENDIF
+         
+         ! ---------------------------------- !
+         ! 4 - initial conservation variables !
+         ! ---------------------------------- !
+         !ssh_ini(:,:) = sshn(:,:)                                       ! initial ssh
+         !DO jk = 1, jpk
+         !   e3t_ini   (:,:,jk) = fse3t_n(:,:,jk)                        ! initial vertical scale factors
+         !   hc_loc_ini(:,:,jk) = tsn(:,:,jk,jp_tem) * fse3t_n(:,:,jk)   ! initial heat content
+         !   sc_loc_ini(:,:,jk) = tsn(:,:,jk,jp_sal) * fse3t_n(:,:,jk)   ! initial salt content
+         !END DO
+         !hcssh_loc_ini(:,:) = tsn(:,:,1,jp_tem) * sshn(:,:)   ! initial heat content in ssh
+         !scssh_loc_ini(:,:) = tsn(:,:,1,jp_sal) * sshn(:,:)   ! initial salt content in ssh
+         !frc_v = 0._wp                                           ! volume       trend due to forcing
+         !frc_t = 0._wp                                           ! heat content   -    -   -    -   
+         !frc_s = 0._wp                                           ! salt content   -    -   -    -         
+         !
+         CALL dia_hsb_rst( nit000, 'READ' )  !* read or initialize all required files
       !
    END SUBROUTINE dia_hsb_init
+
+   SUBROUTINE dia_hsb_rst( kt, cdrw )
+     !!---------------------------------------------------------------------
+     !!                   ***  ROUTINE limdia_rst  ***
+     !!                     
+     !! ** Purpose :   Read or write DIA file in restart file
+     !!
+     !! ** Method  :   use of IOM library
+     !!----------------------------------------------------------------------
+     INTEGER         , INTENT(in) ::   kt     ! ocean time-step
+     CHARACTER(len=*), INTENT(in) ::   cdrw   ! "READ"/"WRITE" flag
+     !
+     INTEGER ::   jk   ! 
+     INTEGER ::   id1   ! local integers
+     !!----------------------------------------------------------------------
+     !
+     IF( TRIM(cdrw) == 'READ' ) THEN        ! Read/initialise 
+        IF( ln_rstart ) THEN                   !* Read the restart file
+           !id1 = iom_varid( numror, 'frc_vol'  , ldstop = .FALSE. )
+           !
+           CALL iom_get( numror, 'frc_v', frc_v )
+           CALL iom_get( numror, 'frc_t', frc_t )
+           CALL iom_get( numror, 'frc_s', frc_s )
+
+           CALL iom_get( numror, jpdom_autoglo, 'ssh_ini', ssh_ini )
+           CALL iom_get( numror, jpdom_autoglo, 'e3t_ini', e3t_ini )
+           CALL iom_get( numror, jpdom_autoglo, 'hc_loc_ini', hc_loc_ini )
+           CALL iom_get( numror, jpdom_autoglo, 'sc_loc_ini', sc_loc_ini )
+           CALL iom_get( numror, jpdom_autoglo, 'hcssh_loc_ini', hcssh_loc_ini )
+           CALL iom_get( numror, jpdom_autoglo, 'scssh_loc_ini', scssh_loc_ini )
+       ELSE
+          ssh_ini(:,:) = sshn(:,:)                                       ! initial ssh
+          DO jk = 1, jpk
+             e3t_ini   (:,:,jk) = fse3t_n(:,:,jk)                        ! initial vertical scale factors
+             hc_loc_ini(:,:,jk) = tsn(:,:,jk,jp_tem) * fse3t_n(:,:,jk)   ! initial heat content
+             sc_loc_ini(:,:,jk) = tsn(:,:,jk,jp_sal) * fse3t_n(:,:,jk)   ! initial salt content
+          END DO
+          hcssh_loc_ini(:,:) = tsn(:,:,1,jp_tem) * sshn(:,:)   ! initial heat content in ssh
+          scssh_loc_ini(:,:) = tsn(:,:,1,jp_sal) * sshn(:,:)   ! initial salt content in ssh
+          frc_v = 0._wp                                           
+          frc_t = 0._wp                                           
+          frc_s = 0._wp                                                  
+       ENDIF	
+
+     ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN   ! Create restart file
+        !                                   ! -------------------
+        IF(lwp) WRITE(numout,*) '---- dia-rst ----'
+        CALL iom_rstput( kt, nitrst, numrow, 'frc_v'   , frc_v     )
+        CALL iom_rstput( kt, nitrst, numrow, 'frc_t'   , frc_t     )
+        CALL iom_rstput( kt, nitrst, numrow, 'frc_s'   , frc_s     )
+        
+        CALL iom_rstput( kt, nitrst, numrow, 'ssh_ini', ssh_ini )
+        CALL iom_rstput( kt, nitrst, numrow, 'e3t_ini', e3t_ini )
+        CALL iom_rstput( kt, nitrst, numrow, 'hc_loc_ini', hc_loc_ini )
+        CALL iom_rstput( kt, nitrst, numrow, 'sc_loc_ini', sc_loc_ini )
+        CALL iom_rstput( kt, nitrst, numrow, 'hcssh_loc_ini', hcssh_loc_ini )
+        CALL iom_rstput( kt, nitrst, numrow, 'scssh_loc_ini', scssh_loc_ini )
+        !
+     ENDIF
+     !
+   END SUBROUTINE dia_hsb_rst
 
    !!======================================================================
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 3938)
@@ -46,4 +46,6 @@
 #if defined key_lim2
    USE limwri_2 
+#elif defined key_lim3
+   USE limwri 
 #endif
    USE lib_mpp         ! MPP library
@@ -743,4 +745,6 @@
       CALL histdef( id_i, "sowaflup", "Net Upward Water Flux" , "Kg/m2/S",   &   ! net freshwater 
          &          jpi, jpj, nh_i, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
+      CALL histdef( id_i, "sosaltfx", "Net Upward Salt Flux"  , "Kg/m2/S",   &   ! net salt flux 
+         &          jpi, jpj, nh_i, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
       CALL histdef( id_i, "sohefldo", "Net Downward Heat Flux", "W/m2"   ,   &   ! net heat flux
          &          jpi, jpj, nh_i, 1  , 1, 1  , -99 , 32, clop, zsto, zout )
@@ -756,4 +760,6 @@
 #if defined key_lim2
       CALL lim_wri_state_2( kt, id_i, nh_i )
+#elif defined key_lim3
+      CALL lim_wri_state( kt, id_i, nh_i )
 #else
       CALL histend( id_i, snc4chunks=snc4set )
@@ -775,4 +781,5 @@
       CALL histwrite( id_i, "vovecrtz", kt, wn               , jpi*jpj*jpk, idex )    ! now k-velocity
       CALL histwrite( id_i, "sowaflup", kt, (emp-rnf )       , jpi*jpj    , idex )    ! freshwater budget
+      CALL histwrite( id_i, "sosaltfx", kt, emps             , jpi*jpj    , idex )    ! freshwater budget
       CALL histwrite( id_i, "sohefldo", kt, qsr + qns        , jpi*jpj    , idex )    ! total heat flux
       CALL histwrite( id_i, "soshfldo", kt, qsr              , jpi*jpj    , idex )    ! solar heat flux
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 3938)
@@ -510,5 +510,5 @@
          zhmin = gdepw_0(ik+1)                                                         ! minimum depth = ik+1 w-levels 
          WHERE( bathy(:,:) <= 0._wp )   ;   bathy(:,:) = 0._wp                         ! min=0     over the lands
-         ELSE WHERE                     ;   bathy(:,:) = MAX(  zhmin , bathy(:,:)  )   ! min=zhmin over the oceans
+         ELSEWHERE                      ;   bathy(:,:) = MAX(  zhmin , bathy(:,:)  )   ! min=zhmin over the oceans
          END WHERE
          IF(lwp) write(numout,*) 'Minimum ocean depth: ', zhmin, ' minimum number of ocean levels : ', ik
@@ -871,5 +871,5 @@
       bathy(:,:) = MIN( zmax ,  bathy(:,:) )    ! bounded value of bathy (min already set at the end of zgr_bat)
       WHERE( bathy(:,:) == 0._wp )   ;   mbathy(:,:) = 0       ! land  : set mbathy to 0
-      ELSE WHERE                     ;   mbathy(:,:) = jpkm1   ! ocean : initialize mbathy to the max ocean level
+      ELSEWHERE                      ;   mbathy(:,:) = jpkm1   ! ocean : initialize mbathy to the max ocean level
       END WHERE
 
@@ -1575,15 +1575,5 @@
             END DO
          END DO
-         DO jj = mj0(74), mj1(74)
-            DO ji = mi0(100), mi1(100)
-               WRITE(numout,*)
-               WRITE(numout,*) ' domzgr: vertical coordinates : point (100,74,k)   bathy = ', bathy(ji,jj), hbatt(ji,jj)
-               WRITE(numout,*) ' ~~~~~~  --------------------'
-               WRITE(numout,"(9x,' level   gdept    gdepw    gde3w     e3t      e3w  ')")
-               WRITE(numout,"(10x,i4,4f9.2)") ( jk, fsdept(ji,jj,jk), fsdepw(ji,jj,jk),     &
-                  &                                 fse3t (ji,jj,jk), fse3w (ji,jj,jk), jk=1,jpk )
-            END DO
-         END DO
-      ENDIF
+       ENDIF
 
 !!gm bug?  no more necessary?  if ! defined key_helsinki
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 3938)
@@ -27,4 +27,5 @@
    USE in_out_manager  ! I/O manager
    USE lib_mpp           ! MPP library
+   USE timing          ! Timing
 #if defined key_iomput
    USE sbc_oce, ONLY :   nn_fsbc         ! ocean space and time domain
@@ -376,5 +377,5 @@
 
 
-   FUNCTION iom_varid ( kiomid, cdvar, kdimsz, ldstop )  
+   FUNCTION iom_varid ( kiomid, cdvar, kdimsz, kndims, ldstop )  
       !!-----------------------------------------------------------------------
       !!                  ***  FUNCTION  iom_varid  ***
@@ -385,4 +386,5 @@
       CHARACTER(len=*)     , INTENT(in   )           ::   cdvar    ! name of the variable
       INTEGER, DIMENSION(:), INTENT(  out), OPTIONAL ::   kdimsz   ! size of the dimensions
+      INTEGER,               INTENT(  out), OPTIONAL ::   kndims   ! size of the dimensions
       LOGICAL              , INTENT(in   ), OPTIONAL ::   ldstop   ! stop if looking for non-existing variable (default = .TRUE.)
       !
@@ -416,5 +418,5 @@
                   SELECT CASE (iom_file(kiomid)%iolib)
                   CASE (jpioipsl )   ;   iom_varid = iom_ioipsl_varid( kiomid, cdvar, iiv, kdimsz )
-                  CASE (jpnf90   )   ;   iom_varid = iom_nf90_varid  ( kiomid, cdvar, iiv, kdimsz )
+                  CASE (jpnf90   )   ;   iom_varid = iom_nf90_varid  ( kiomid, cdvar, iiv, kdimsz, kndims )
                   CASE (jprstdimg)   ;   iom_varid = -1   ! all variables are listed in iom_file
                   CASE DEFAULT   
@@ -437,4 +439,5 @@
                   ENDIF
                ENDIF
+               IF( PRESENT(kndims) )  kndims = iom_file(kiomid)%ndims(iiv)
             ENDIF
          ENDIF
@@ -959,4 +962,5 @@
       CHARACTER(LEN=*), INTENT(in) ::   cdname
       REAL(wp)        , INTENT(in) ::   pfield0d
+      IF( nn_timing == 1 )  CALL timing_start('iom_put0')
 #if defined key_iomput
       CALL event__write_field2D( cdname, RESHAPE( (/pfield0d/), (/1,1/) ) )
@@ -964,4 +968,5 @@
       IF( .FALSE. )   WRITE(numout,*) cdname, pfield0d   ! useless test to avoid compilation warnings
 #endif
+      IF( nn_timing == 1 )  CALL timing_stop('iom_put0')
    END SUBROUTINE iom_p0d
 
@@ -970,4 +975,5 @@
       REAL(wp),     DIMENSION(:), INTENT(in) ::   pfield1d
       INTEGER :: jpz
+      IF( nn_timing == 1 )  CALL timing_start('iom_put1')
 #if defined key_iomput
       jpz=SIZE(pfield1d)
@@ -976,4 +982,5 @@
       IF( .FALSE. )   WRITE(numout,*) cdname, pfield1d   ! useless test to avoid compilation warnings
 #endif
+      IF( nn_timing == 1 )  CALL timing_stop('iom_put1')
    END SUBROUTINE iom_p1d
 
@@ -981,4 +988,5 @@
       CHARACTER(LEN=*)            , INTENT(in) ::   cdname
       REAL(wp),     DIMENSION(:,:), INTENT(in) ::   pfield2d
+      IF( nn_timing == 1 )  CALL timing_start('iom_put2')
 #if defined key_iomput
       CALL event__write_field2D( cdname, pfield2d(nldi:nlei, nldj:nlej) )
@@ -986,4 +994,5 @@
       IF( .FALSE. )   WRITE(numout,*) cdname, pfield2d   ! useless test to avoid compilation warnings
 #endif
+      IF( nn_timing == 1 )  CALL timing_stop('iom_put2')
    END SUBROUTINE iom_p2d
 
@@ -991,4 +1000,5 @@
       CHARACTER(LEN=*)                , INTENT(in) ::   cdname
       REAL(wp),       DIMENSION(:,:,:), INTENT(in) ::   pfield3d
+      IF( nn_timing == 1 )  CALL timing_start('iom_put3')
 #if defined key_iomput
       CALL event__write_field3D( cdname, pfield3d(nldi:nlei, nldj:nlej, :) )
@@ -996,4 +1006,5 @@
       IF( .FALSE. )   WRITE(numout,*) cdname, pfield3d   ! useless test to avoid compilation warnings
 #endif
+      IF( nn_timing == 1 )  CALL timing_stop('iom_put3')
    END SUBROUTINE iom_p3d
    !!----------------------------------------------------------------------
@@ -1070,4 +1081,6 @@
       CALL event__set_attribut( 'field_definition', attr( field__freq_op, idt           ) )    ! model time-step
       CALL event__set_attribut( 'SBC'             , attr( field__freq_op, idt * nn_fsbc ) )    ! SBC time-step
+ !SF 
+      CALL event__set_attribut( 'scalar_SBC'      , attr( field__freq_op, idt * nn_fsbc ) )    ! SBC time-step
       
       ! output file names (attribut: name)
